--- asterisk-1.4.22/channels/chan_dahdi.c.orig	2008-12-10 11:59:36.000000000 +0000
+++ asterisk-1.4.22/channels/chan_dahdi.c	2008-12-29 23:08:45.000000000 +0000
@@ -6311,6 +6311,7 @@
 						}
 						if (i & DAHDI_IOMUX_SIGEVENT) {
 							res = dahdi_get_event(p->subs[index].dfd);
+							if (res == DAHDI_EVENT_NOALARM) p->inalarm = 0;
 							ast_log(LOG_NOTICE, "Got event %d (%s)...\n", res, event2str(res));
 
 							if (p->cid_signalling == CID_SIG_V23_JP) {
@@ -6415,6 +6422,7 @@
 							if (i & DAHDI_IOMUX_SIGEVENT) {
 								res = dahdi_get_event(p->subs[index].dfd);
 								ast_log(LOG_NOTICE, "Got event %d (%s)...\n", res, event2str(res));
+								if (res == DAHDI_EVENT_NOALARM) p->inalarm = 0;
 								res = 0;
 								/* Let us detect distinctive ring */
 		
@@ -6520,6 +6528,7 @@
 					if (i & DAHDI_IOMUX_SIGEVENT) {
 						res = dahdi_get_event(p->subs[index].dfd);
 						ast_log(LOG_NOTICE, "Got event %d (%s)...\n", res, event2str(res));
+						if (res == DAHDI_EVENT_NOALARM) p->inalarm = 0;
 						/* If we get a PR event, they hung up while processing calerid */
 						if ( res == DAHDI_EVENT_POLARITY && p->hanguponpolarityswitch && p->polarity == POLARITY_REV) {
 							ast_log(LOG_DEBUG, "Hanging up due to polarity reversal on channel %d while detecting callerid\n", p->channel);
@@ -6591,6 +6600,7 @@
 						if (i & DAHDI_IOMUX_SIGEVENT) {
 							res = dahdi_get_event(p->subs[index].dfd);
 							ast_log(LOG_NOTICE, "Got event %d (%s)...\n", res, event2str(res));
+							if (res == DAHDI_EVENT_NOALARM) p->inalarm = 0;
 							res = 0;
 							/* Let us detect callerid when the telco uses distinctive ring */
 
